
namespace eval Function {
    variable insert_data {
       R0lGODlhGAAYAOMAAAICBK2tmo2NgOXlztXVvzY2MlxcWfLy2///////////
       /////////////////////yH5BAEKAAgALAAAAAAYABgAAAR4EMlJq704awu2
       BkDQeRVIDERBTibhnuPWuugwiLLw7vagfr5Xr3eIXQCHQ4E3SKKMpWZBN0wm
       oRSkQdi0WrGSVs3mTeI43G45ScACaCfy+tA+DtVlEOZ9Lw/AFAZyZQKAWU14
       fysISFZPi4wEbAaGGUh1kFmVmRoRADs=
    }
    variable insert [image create photo -data [set insert_data]]
    
    variable get_data {
       R0lGODlhGAAYAOMAAAICBK2tmo2NgOXlztXVvzY2MlxcWfLy2///////////
       /////////////////////yH5BAEKAAgALAAAAAAYABgAAAR/EMlJq704awu2
       BkDQeRVIDERBTibhnuPWuugwiLLw7vagfj4XoGcDHGIX46FAMBWHzcxwKQD1
       QIej9GAQDozgrDYJoA3PRzGO8/p+08pstERrFrPxw7x0HaT/R0gUZUR+Ygdf
       GwY2h2JVHlOGWYkreSiCMgRyBpiQep2VoCujEQA7
    }
    variable get [image create photo -data [set get_data]]


    
    variable delete_data {
       R0lGODlhDwAPAKEAAP8AAICAgAAAAP///yH+Dk1hZGUgd2l0aCBHSU1QACH5
       BAEKAAMALAAAAAAPAA8AAAIxnI+AAxDbXJIstnesvlOLj2XWJyzVWEKNYIUi
       wEbu+RnyW4vhmk4p3IOkcqYBsWgqAAA7
    }
    variable delete [image create photo -data [set delete_data]]
    
    variable entrytype
    variable deltax
    variable x 
    variable y
    variable tox
    variable toy
    variable ldeltax
    variable lx
    variable ly
    variable ltox
    variable ltoy
    variable edeltax
    variable ex
    variable ey
    variable etox
    variable etoy
    variable etoy2
    variable index 0
    variable insertype
    variable table

} 
proc Function::ComunicateWithGiD { op args } {
    
    switch $op {
	"INIT" {
	    set PARENT [lindex $args 0]
	    upvar      [lindex $args 1] ROW
	    set GDN [lindex $args 2]
  	    set STRUCT [lindex $args 3]
	    set f [frame $PARENT.f]
	    Function::initwindow $f 
	    grid $f -row $ROW -col 0 -sticky nsew -columnspan 2 -pady 3 -padx 2
	    grid rowconf $PARENT $ROW -weight 1
	    grid columnconf $PARENT 1 -weight 1
	    upvar \#0 $GDN GidData
	     if { $GidData($STRUCT,VALUE,3) != "#N# 1 none" } {
		  Function::getvalues $GidData($STRUCT,VALUE,3)
	     }
	     return ""
	 }
	 "SYNC" {
	    set GDN [lindex $args 0]
  	    set STRUCT [lindex $args 1]
	    set values [Function::dump]
	    
	    DWLocalSetValue $GDN $STRUCT  "Table_Interpolation_Values:" $values
	    return ""
	}
    }
}
proc  Function::getvalues { entries } {
    variable table
    
    set nelems [lindex $entries 1]
    set nelems [expr $nelems-1] 
    for { set i 2 } { $i <= $nelems  } { incr i 2 } {
	set x [lindex $entries $i ]
	set y [lindex $entries [expr $i+1]]
	$table insert end "[format %#16e $x] [format %#16e $y]"
    }
    
}

proc Function::initwindow { parent } {
    variable table
        
    set w $parent
    #-------------------------Crear Table values-----------------------------------#
    set pw [PanedWindow $w.pw -side top -width 10]
    set pane [$pw add -weight 1 ]
    set title1 [TitleFrame $pane.tablevalues -relief groove -bd 2 -text "Table Values" -side left]
    set f1 [$title1 getframe]
    set sw [gScrolledWindow $f1.scroll -scrollbar vertical  -grid "0 nsew"]
    set table [tablelist::tablelist $f1.scroll.table \
	    -columns {0 "X Values" center 0 "Y Values" center} \
	    -stretch all -background white -labelbg lightyellow \
	    -listvariable Function::list]
    $sw setwidget $table
    set bbox [gButtonBox $f1.bbox1 -spacing 0 -padx 1 -pady 1 -homogeneous 0 -grid "0 wn"]
    #$bbox add -image $Function::insert -width 24 \
    #    -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
    #    -helptext "Insert a new entry" -command "Function::insert $table"
    $bbox add -image $Function::get -width 24 \
        -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
        -helptext "Edit entry" -command "Function::edit $table"
    $bbox add -image $Function::delete -width 24 \
        -highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
        -helptext "Delete entry" -command "Function::delete $table"
  
#---------------------------Crear Data Entry-------------------------------------------------#
    set pane2 [$pw add -weight 1]
    set title2 [TitleFrame $pane2.data -relief groove -bd 2 -text "Data Entry" -side left]
    set f2 [$title2 getframe]
    
    catch { unset bgcolor }
    set bgcolor [$f2 cget -background]
    set Function::entrytype "Single Value"
    trace variable Function::entrytype w "Function::modify ;# "
    
    gframe $f2.f -grid "0 4 py6"
    gradiobutton $f2.f.single -text "Single Value" -var Function::entrytype \
	    -value "Single Value"  -selectcolor white -grid 0
    gradiobutton $f2.f.linear -text "Linear Ramp" -var Function::entrytype \
	    -value "Linear Ramp" -selectcolor white -grid 1
    gradiobutton $f2.f.equation -text "Equation" -var Function::entrytype \
	    -value "Equation" -selectcolor white -grid "0 wn"
    gradiobutton $f2.f.periodic -text "Periodic" -var Function::entrytype \
	    -value "Periodic" -selectcolor white -grid "1 wn"
    
    set Function::x "" 
    set Function::y ""
    set Function::deltax ""
    set Function::tox ""
    set Function::toy ""   
    
    set Function::ldeltax [glabel $f2.ldeltax -text "Delta X" -justify right \
	    -disabledforeground grey60 -foreground black -state disabled -grid "0 py1"]
    set Function::edeltax [gentry $f2.edeltax -textvariable Function::deltax \
	    -justify left -bd 2 -relief sunken  -background $bgcolor \
	    -state disabled -grid "1 py1"] 
    set Function::lx [glabel $f2.lx -text X -justify right -grid "0 py1"]
    set Function::ex [gentry $f2.ex -textvariable Function::x -justify left \
	    -bd 2  -relief sunken -grid "1 py1"]
    set Function::ly [glabel $f2.ly -text Y -justify right -disabledforeground grey60 \
	    -foreground black -state normal -grid "2 py1"]
    set Function::ey [gentry $f2.ey -textvariable Function::y -justify left  -bd 2 \
	    -relief sunken -state normal -grid "3 py1"]
    set Function::ltox [glabel $f2.ltox -text "To X" -justify right \
	    -disabledforeground grey60 -foreground black -state disabled -grid "0 py1"]
    set Function::etox [gentry $f2.etox -textvariable Function::tox -justify left \
	    -bd 2  -relief sunken -background $bgcolor -state disabled -grid "1 py1"]
    set Function::ltoy [glabel $f2.ltoy -text "To Y" -justify right \
	    -disabledforeground grey60 -foreground black -state disabled -grid "2 py1"]
    gframe $f2.etoy -grid "3 ewns"
    set Function::etoy [entry $f2.etoy.e -textvariable Function::toy -justify left \
	    -bd 2 -relief sunken -background $bgcolor -state disabled]
    set examples { 3*x+log(x) pow(x,2)*exp(x) x*cos(3*x) sqrt(x+2)+sinh(pow(x,3)) \
	    atan(x) abs(x) }
    set Function::etoy2 [ComboBox $f2.etoy.cb -textvariable Function::toy  \
	    -background $bgcolor -values $examples]
    frame $pane2.fadd 
    button $pane2.fadd.badd -text Add -underline 0 -padx 5 -command "Function::add $table" 
    button $pane2.fadd.bclear -text "Clear All" -underline 1 -padx 5 \
	    -command "Function::clear $table"  
    frame $pane2.fradio1
    frame $pane2.fradio2
    set Function::insertype end
    radiobutton $pane2.fradio1.end -text "Add at End" -variable  Function::insertype \
	    -justify left -value end 
    radiobutton $pane2.fradio2.no -text "Add before Selected" -variable  Function::insertype \
	    -value no 
   
#------------------------Empaquetat amd grid i supergrid-------------------------------------#
    grid rowconf $w 0 -weight 1
    grid columnconf $w 0 -weight 1
    
    grid $pw  -sticky nsew
    grid rowconf $pw 0 -weight 1
    grid columnconf $pw 0 -weight 1
    grid rowconf $pane 0 -weight 1
    grid columnconf $pane 0 -weight 1
    grid rowconf $pane2 4 -weight 1
    grid columnconf $pane2 0 -weight 1
    
    grid $title1 -column 0 -row 0 -padx 2 -pady 2 -sticky nsew 
    grid rowconf $title1 2 -weight 1
    
    
    grid $title2 -column 0 -row 0 -padx 2 -pady 2 -sticky nsew
        
    
   
    grid $f2.etoy.e -row 0 -col 0 -sticky nsew
    grid $f2.etoy.cb -row 0 -col 0 -sticky nsew
    grid columnconf $f2.etoy 0 -weight 1
    grid rowconf $f2.etoy 0 -weight 1
    grid remove $f2.etoy.cb
    grid propagate $f2.etoy 0
    
    grid $pane2.fadd -row 1 -column 0 -sticky nsew 
    grid columnconf $pane2.fadd 1 -weight 1
    grid $pane2.fadd.badd -row 0 -column 0 -padx 5 -pady 5
    grid $pane2.fadd.bclear -row 0 -column 1 -padx 5 -pady 5
    grid $pane2.fradio1 -row 2 -column 0 -sticky nsew 
    grid $pane2.fradio2 -row 3 -column 0 -sticky nsew
    grid columnconf $pane2.fradio1 1 -weight 1
    grid columnconf $pane2.fradio2 1 -weight 1
    grid $pane2.fradio1.end -row 0 -column 0 
    grid $pane2.fradio2.no -row 1 -column 0
    
    supergrid::go $f1
    supergrid::go $f2
    
 
    bind $table <Double-ButtonPress-1> "Function::edit $table"
    bind $w <Alt-KeyPress-a> "tkButtonInvoke $pane2.fadd.badd"
    bind $w <Alt-KeyPress-l> "tkButtonInvoke $pane2.fadd.bclear"
}

#----------------------------------------Modificacio finestra--------------------------------#
proc Function::modify { } {

    if { ![winfo exists $Function::ldeltax] } { return }
    
    catch { unset bgcolor }
    set bgcolor [$Function::ldeltax cget -background]  
    
    if { $Function::entrytype == "Single Value" } {
	set Function::deltax "" 
	set Function::x ""
	set Function::y ""
	set Function::tox ""
	set Function::toy ""
	$Function::ldeltax configure -state disable  -text "Delta X"
	$Function::edeltax configure -state disable -background $bgcolor 
	$Function::ly configure -state normal
	$Function::ey configure -state normal -background white
	$Function::ltox configure -state disable  
	$Function::etox configure -state disable -background $bgcolor
	$Function::ltoy configure -state disabled -text "To Y"
	$Function::etoy configure -state disabled -background $bgcolor

	grid $Function::etoy
	grid remove $Function::etoy2 


    }
    if { $Function::entrytype == "Linear Ramp" } {
	set Function::deltax "" 
	set Function::x ""
	set Function::y ""
	set Function::tox ""
	set Function::toy ""
	$Function::ldeltax configure -state normal -text "Delta X"
	$Function::edeltax configure -state normal -background white
	$Function::ly configure -state normal
	$Function::ey configure -state normal -background white
	$Function::ltox configure -state normal  
	$Function::etox configure -state normal -background white
	$Function::ltoy configure -state normal -text "To Y"
	$Function::etoy configure -state normal -background white 
	grid $Function::etoy
	grid remove $Function::etoy2 
    }
    if { $Function::entrytype == "Equation" } {
	set Function::deltax "" 
	set Function::x ""
	set Function::y ""
	set Function::tox ""
	set Function::toy ""
	$Function::ldeltax configure -state normal -text "Delta X"
	$Function::edeltax configure -state normal -background white
	$Function::ly configure -state disabled
	$Function::ey configure -state disabled -background $bgcolor
	$Function::ltox configure -state normal  
	$Function::etox configure -state normal -background white
	$Function::ltoy configure -state normal -text Y(X)
	$Function::etoy configure -state normal -background white 
	grid $Function::etoy2
	grid remove $Function::etoy 
    }
    if { $Function::entrytype == "Periodic" } {
	set Function::deltax "" 
	set Function::x ""
	set Function::y ""
	set Function::tox ""
	set Function::toy ""
	$Function::ldeltax configure -state normal -text Period
	$Function::edeltax configure -state normal -background white
	$Function::ly configure -state normal
	$Function::ey configure -state normal -background white
	$Function::ltox configure -state normal  
	$Function::etox configure -state normal -background white
	$Function::ltoy configure -state disabled -text "To Y"
	$Function::etoy configure -state disabled -background $bgcolor 
	grid $Function::etoy
	grid remove $Function::etoy2 
    } 
}



proc Function::add { wtext } {
    variable entrytype
    variable deltax
    variable x
    variable y
    variable tox
    variable toy
    variable index
    variable insertype
     
    
    if { [errorcntrl] } {  
	if { $insertype == "end" } {
	    if { $entrytype == "Single Value" } {
		$wtext insert $index "[format %#16e $x] [format %#16e $y]"
		$wtext see end
		set index [expr $index+1]
	    }
	    if { $entrytype == "Linear Ramp" } {
		set x [expr double($x)]
		set tox [expr double($tox)]
		set deltax [expr double($deltax)]
		set numint [expr abs([expr round([expr ($x-$tox)/$deltax])])]
		set v1 [expr double([expr $tox-$x])]
		set v2 [expr double([expr $toy-$y])]
		set b [expr $y-$x*$v2/$v1]
		set m [expr $v2/$v1]
		for { set i 0 } { $i<=$numint } { incr i } {
		    set xi [expr $x+$i*$deltax]
		    set yi [expr $m*$xi+$b]
		    $wtext insert $index "[format %#16e $xi] [format %#16e $yi]"
		    $wtext see end
		    set index [expr $index+1]
		}
	    }
	    if { $entrytype == "Equation" } {
		set x [expr double($x)]
		set tox [expr double($tox)]
		set deltax [expr double($deltax)]
		set numint [expr abs([expr round([expr ($x-$tox)/$deltax])])]
		string tolower $toy
		regsub -all {\mx\M} $toy \$xi aux
		for { set i 0 } { $i<=$numint } { incr i } {
		    set xi [expr double([expr $x+$i*$deltax])]
		    set yi [expr $aux]
		    $wtext insert $index "[format %#16e $xi] [format %#16e $yi]"
		    $wtext see end
		    set index [expr $index+1]
		}
	    }
	    if { $entrytype == "Periodic" } {
		set x [expr double($x)]
		set tox [expr double($tox)]
		set deltax [expr double($deltax)]
		set numint [expr abs([expr round([expr ($x-$tox)/$deltax])])]
		for { set i 0 } { $i<=$numint } { incr i } {
		    set xi [expr $x+$i*$deltax]
		    $wtext insert $index "[format %#16e $xi] [format %#16e $y]"
		    $wtext see end
		    set index [expr $index+1]
		}
	    }
	}
	if { $insertype == "no" } {
	    set entry [$wtext curselection]
	    if { $entry == "" } {
		WarnWin " It is necessary to select a row of values"
	    } else {
		if { $entrytype == "Single Value" } {
		$wtext insert $entry "[format %#16e $x] [format %#16e $y]"
		    $wtext see $entry
		}
		if { $entrytype == "Linear Ramp" } {
		    set x [expr double($x)]
		    set tox [expr double($tox)]
		    set deltax [expr double($deltax)]
		    set numint [expr abs([expr round([expr ($x-$tox)/$deltax])])]
		    set v1 [expr double([expr $tox-$x])]
		    set v2 [expr double([expr $toy-$y])]
		    set b [expr $y-$x*$v2/$v1]
		    set m [expr $v2/$v1]
		    for { set i 0 } { $i<=$numint } { incr i } {
		    set xi [expr $x+$i*$deltax]
			set yi [expr $m*$xi+$b]
			$wtext insert $entry "[format %#16e $xi] [format %#16e $yi]"
			$wtext see $entry
			set entry [expr $entry+1]
		    }
		}
		if { $entrytype == "Equation" } {
		    set x [expr double($x)]
		    set tox [expr double($tox)]
		    set deltax [expr double($deltax)]
		    set numint [expr abs([expr round([expr ($x-$tox)/$deltax])])]
		    string tolower $toy
		    regsub -all {\mx\M} $toy \$xi aux
		    for { set i 0 } { $i<=$numint } { incr i } {
		    set xi [expr double([expr $x+$i*$deltax])]
			set yi [expr $aux]
			$wtext insert $entry "[format %#16e $xi] [format %#16e $yi]"
			$wtext see $entry
			set entry [expr $entry+1]
		    }
		}
		if { $entrytype == "Periodic" } {
		    set x [expr double($x)]
		    set tox [expr double($tox)]
		    set deltax [expr double($deltax)]
		    set numint [expr abs([expr round([expr ($x-$tox)/$deltax])])]
		    for { set i 0 } { $i<=$numint } { incr i } {
			set xi [expr $x+$i*$deltax]
			$wtext insert $entry "[format %#16e $xi] [format %#16e $y]"
			$wtext see $entry
			set entry [expr $entry+1]
		    } 
		}
	    }
	}
    }
}
proc Function::edit { table } {
    
    variable x
    variable y

    set index [$table curselection]
    if { $index != "" } {
	set entry [$table get $index]
	set x [lindex $entry 0]  
	set y [lindex $entry 1]
    }
} 
	
proc Function::delete { wtext } {
    variable x
    variable y

    set entry [$wtext curselection]
    if { $entry != "" } {
	if { [string index $entry 0] >  [string index $entry end]} {
	$wtext delete [string index $entry end] [string index $entry 0]
	$wtext see [string index $entry end]
	}
	if { [string index $entry 0] <=  [string index $entry end]} {
	$wtext delete [string index $entry 0] [string index $entry end]
	$wtext see [string index $entry 0]
	}
    }   
}


proc Function::errorcntrl { } {
    variable deltax
    variable x
    variable y
    variable tox
    variable entrytype  
    set cntrlx 0
    set cntrly 0
    set cntrltox 0
    set cntrldeltax 0
    set text "Please make sure all activated fields are filled only with numerical values."
    set texteq "Please make sure all activated fields are filled only with \
	    numerical values.\nOnly the Y(X) field can be filled with an \
	    equation including alphabetical\ncharacters."
    
    if { [string is double -strict $x] || [string is integer -strict $x] } {
	set cntrlx 1
    } 
    if { [string is double -strict $y] || [string is integer -strict $y] } {
	set cntrly 1
    }
    if { [string is double -strict $tox] || [string is integer -strict $tox] } {
	set cntrltox 1
    }
    if { [string is double -strict $deltax] || [string is integer -strict $deltax] } {
	set cntrldeltax 1
    }

    if { $entrytype == "Single Value"  } {
	if { [expr $cntrlx+$cntrly] == 2 } {
	    return 1
	} else {
	    set text [append text "\n\nErrors found:"]
	    if { $cntrlx == 0 } {
		set text [append text "\nX file is blank or filled with alphabetical \
			characters."] 
	    }
	    if { $cntrly == 0 } {
		set text [append  text "\nY file is blank or filled with alphabetical \
			characters."] 
	    }
	    WarnWin $text
	    return 0
	}
    }
    if { $entrytype == "Linear Ramp"  } {
	if { [expr $cntrlx+$cntrly+$cntrldeltax+$cntrltox] == 4 } {
	    return 1
	} else {
	    set text [append text "\n\nErrors found:"]
	    if { $cntrlx == 0 } {
		set text [append text "\nX file is blank or filled with alphabetical \
			characters."] 
	    }
	    if { $cntrly == 0 } {
		set text [append  text "\nY file is blank or filled with \
			alphabetical characters."] 
	    }
	    if { $cntrldeltax == 0 } {
		set text [append text "\nDelta X file is blank or filled with \
			alphabetical characters."] 
	    }
	    if { $cntrltox == 0 } {
		set text [append  text "\nToX file is blank or filled with \
			alphabetical characters."] 
	    }
	    WarnWin $text
	    return 0
	}
    }
    if { $entrytype == "Equation"  } {
	if { [expr $cntrlx+$cntrldeltax+$cntrltox] == 3 } {
	    return 1
	} else {
	    set texteq [append texteq "\n\nErrors found:"]
	    if { $cntrlx == 0 } {
		set texteq [append texteq "\nX file is blank or filled with \
			alphabetical characters."] 
	    }
	    if { $cntrltox == 0 } {
		set texteq [append  texteq "\nToX file is blank or filled with \
			alphabetical characters."] 
	    }
	    if { $cntrldeltax == 0 } {
		set texteq [append texteq "\nDelta X file is blank or filled with \
			alphabetical characters."] 
	    }
	    WarnWin $texteq
	    return 0
	}
    }
    if { $entrytype == "Periodic"  } {
	if { [expr $cntrlx+$cntrldeltax+$cntrltox+$cntrly] == 4 } {
	    return 1
	} else {
	    set text [append text "\n\nErrors found:"]
	    if { $cntrlx == 0 } {
		set text [append text "\nX file is blank or filled with \
			alphabetical characters."] 
	    }
	    if { $cntrldeltax == 0 } {
		set text [append text "\nDelta X file is blank or filled with \
			alphabetical characters."] 
	    }
	    if { $cntrltox == 0 } {
		set text [append  text "\nToX file is blank or filled with \
			alphabetical characters."] 
	    }
	    if { $cntrly == 0 } {
		set text [append  text "\nY file is blank or filled with \
			alphabetical characters."] 
	    }
	    WarnWin $text
	    return 0
	}
    }
}

proc Function::dump { } {
    variable table
    set nelem [$table index end]
    if { $nelem == 0 } {
	set values "#N# 1 none"
    }
    set nelem [expr 2*$nelem+1]
    set values "#N#" 
    set values [append values " $nelem"]
   foreach currentinput [$table get 0 end] {
	set currentinput [string trim $currentinput]
	set values [append values " $currentinput"]
    }
    set values [append values " none"]
    return $values
}

proc Function::clear { values } {
    variable table
    
    set answer [tk_dialogRAMFull $table.empwiniw {information window} \
	    "Are you sure you want to clear all  values ?" \
	    "" "" gidquestionhead 0 OK Cancel]
    if { $answer == 0 } {
	$values delete 0 end
    }    
}
